#!/bin/bash
#SBATCH --job-name=qed_bench
#SBATCH --partition=casus_a100
#SBATCH --account=casus
#SBATCH --time=8:00:00
#SBATCH --nodes=1
#SBATCH --ntasks=1
#SBATCH --cpus-per-task=128
#SBATCH --gres=gpu:4
#SBATCH --mem=2048GB
#SBATCH --output=simulation-%A-%a.out
#SBATCH --error=simulation-%A-%a.err

cd $HOME/repos/metagraph_optimization

module load singularity
module load git
module load cuda/12.1

printf "Current git commit hash: " > results/git_reduce_bench_gpu.txt
git rev-parse HEAD >> results/git_reduce_bench_gpu.txt
git status >> results/git_reduce_bench_gpu.txt

singularity exec --nv experiments/CUDA_container.sif ./experiments/full_node.sh
